Part Module/sv: Difference between revisions

From FreeCAD Documentation
(Created page with "Vi skulle kunna säga att geometriprimitiver är "formlösa" byggblock, och former är den riktiga spatiala geometrin som är byggd på dem.")
(Redirected page to Part Workbench/sv)
Tag: New redirect
 
(108 intermediate revisions by 4 users not shown)
Line 1: Line 1:
#REDIRECT [[Part_Workbench/sv]]
FreeCAD's CAD kapabilitet är baserad på [http://en.wikipedia.org/wiki/Open_CASCADE OpenCasCade] kärnan. Del modulen tillåter FreeCAD att komma åt och använda OpenCasCade objekt och funktioner. OpenCascade är en professionell CAD kärna, som erbjuder avancerad 3D geometrimanipulation och objekt. Del objekten, till skillnad från [[Mesh Module/se|Nätmodul]] objekten, är mycket komplexare, och tillåter därför mycket mer avancerade operationer, som koherenta booleska operationer, ändringshistorik och parametriskt beteende.

[[Image:Part example.jpg]]

Exempel på Del former i FreeCAD

=== Verktygen ===

Alla Del modul verktygen finns i '''Del''' menyn som kommer fram när du laddar Del modulen.

{{Part Tools/sv}}

=== Booleska Operationer ===

[[Image:Part_BooleanOperations.png|500px|left|An example of union (Fuse), intersection (Common) and difference (Cut)]]

{{clear}}

Ett exempel på förening (ihopsmältning), skärning (Gemensam) och skillnad (Klipp)

=== Förklaring av koncepten ===

I OpenCasCade terminologi, så skiljer vi mellan geometriska primitiver och (topologiska) former. En geometrisk primitiv kan vara en punkt, en linje, en cirkel, ett plan, etc. eller även mer komplexa typer som en B-Spline kurva eller yta. En form kan vara ett hörn, en kant, en tråd, en yta, en solid eller en sammansättning av andra former. De geometriska primitiverna är inte gjorda för att direkt visas i 3D scenen, utan snarare för att användas som bygggeometri för former. Till exempel så kan en kant skapas av en linje eller av en cirkeldel.

Vi skulle kunna säga att geometriprimitiver är "formlösa" byggblock, och former är den riktiga spatiala geometrin som är byggd på dem.

To get a complete list of all of them refer to the [http://www.opencascade.org/org/doc/ OCC documentation] (Alternative: [http://opencascade.sourcearchive.com/documentation/6.3.0.dfsg.1-1/classes.html sourcearchive.com]) and search for '''Geom_*''' (for geometry) and '''TopoDS_*''' (for shapes). There you can also read more about the differences between geometric objects and shapes. Please note that unfortunately the official OCC documentation is not available online (you must download an archive) and is mostly aimed at programmers, not at end-users. But hopefully you'll find enough information to get started here.

The geometric types actually can be divided into two major groups: curves and surfaces. Out of the curves (line, circle, ...) you can directly build an edge, out of the surfaces (plane, cylinder, ...) a face can be built. For example, the geometric primitive line is unlimited, i.e. it is defined by a base vector and a direction vector while its shape representation must be something limited by a start and end point. And a box -- a solid -- can be created by six limited planes.

From an edge or face you can also go back to its geometric primitive counter part.

Thus, out of shapes you can build very complex parts or, the other way round, extract all sub-shapes a more complex shape is made of.

=== Scripting ===

The main data structure used in the Part module is the [http://en.wikipedia.org/wiki/Boundary_representation BRep] data type from OpenCascade.
Almost all contents and object types of the Part module are now available to python scripting. This includes geometric primitives, such as Line and Circle (or Arc), and the whole range of TopoShapes, like Vertexes, Edges, Wires, Faces, Solids and Compounds. For each of those objects, several creation methods exist, and for some of them, especially the TopoShapes, advanced operations like boolean union/difference/intersection are also available. Explore the contents of the Part module, as described in the [[FreeCAD Scripting Basics]] page, to know more.

=== Examples ===

To create a line element switch to the Python console and type in:
<syntaxhighlight>
import Part,PartGui
doc=App.newDocument()
l=Part.Line()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)
doc.addObject("Part::Feature","Line").Shape=l.toShape()
doc.recompute()
</syntaxhighlight>
Let's go through the above python example step by step:
<syntaxhighlight>
import Part,PartGui
doc=App.newDocument()
</syntaxhighlight>
loads the Part module and creates a new document
<syntaxhighlight>
l=Part.Line()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)
</syntaxhighlight>
Line is actually a line segment, hence the start and endpoint.
<syntaxhighlight>
doc.addObject("Part::Feature","Line").Shape=l.toShape()
</syntaxhighlight>
This adds a Part object type to the document and assigns the shape representation of the line segment to the 'Shape' property of the added object. It is important to understand here that we used a geometric primitive (the Part.Line) to create a TopoShape out of it (the toShape() method). Only Shapes can be added to the document. In FreeCAD, geometry primitives are used as "building structures" for Shapes.
<syntaxhighlight>
doc.recompute()
</syntaxhighlight>
Updates the document. This also prepares the visual representation of the new part object.

Note that a Line can be created by specifying its start and endpoint directly in the constructor, for example Part.Line(point1,point2), or we can create a default line and set its properties afterwards, as we did here.

A circle can be created in a similar way:
<syntaxhighlight>
import Part
doc = App.activeDocument()
c = Part.Circle()
c.Radius=10.0
f = doc.addObject("Part::Feature", "Circle")
f.Shape = c.toShape()
doc.recompute()
</syntaxhighlight>
Note again, we used the circle (geometry primitive) to construct a shape out of it. We can of course still access our construction geometry afterwards, by doing:
<syntaxhighlight>
s = f.Shape
e = s.Edges[0]
c = e.Curve
</syntaxhighlight>
Here we take the shape of our object f, then we take its list of edges. In this case there will be only one because we made the whole shape out of a single circle, so we take only the first item of the Edges list, and we takes its curve. Every Edge has a Curve, which is the geometry primitive it is based on.

Head to the [[Topological data scripting]] page if you would like to know more.

{{docnav|Mesh Module|Drawing Module}}

[[Category:User Documentation]]
<languages/>

Latest revision as of 14:58, 27 April 2024

Redirect to: